<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="fr"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>RewardsService.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">TourGuide</a> &gt; <a href="index.source.html" class="el_package">tourGuide.service</a> &gt; <span class="el_source">RewardsService.java</span></div><h1>RewardsService.java</h1><pre class="source lang-java linenums">package tourGuide.service;

import java.util.List;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.stream.Collectors;
import org.springframework.stereotype.Service;
import gpsUtil.location.Attraction;
import gpsUtil.location.Location;
import gpsUtil.location.VisitedLocation;
import rewardCentral.RewardCentral;
import tourGuide.user.User;
import tourGuide.user.UserReward;

@Service
public class RewardsService {
    private static final double STATUTE_MILES_PER_NAUTICAL_MILE = 1.15077945;

<span class="fc" id="L20">	private int proximityBuffer = Integer.MAX_VALUE;</span>
	private final RewardCentral rewardsCentral;
<span class="fc" id="L22">	private final ExecutorService service = Executors.newCachedThreadPool();</span>
	private final GpsUtilService gpsUtilService;

	
<span class="fc" id="L26">	public RewardsService(RewardCentral rewardCentral, GpsUtilService gpsUtilService) {</span>
<span class="fc" id="L27">		this.rewardsCentral = rewardCentral;</span>
<span class="fc" id="L28">		this.gpsUtilService = gpsUtilService;</span>
<span class="fc" id="L29">	}</span>
	
	public void setProximityBuffer(int proximityBuffer) {
<span class="fc" id="L32">		this.proximityBuffer = proximityBuffer;</span>
<span class="fc" id="L33">	}</span>

	public boolean isWithinAttractionProximity(Attraction attraction, Location location) {
<span class="fc" id="L36">		int attractionProximityRange = 200;</span>
<span class="pc bpc" id="L37" title="1 of 2 branches missed.">		return (getDistance(attraction, location) &lt;= attractionProximityRange);</span>
	}

	public void calculateRewards(User user) {
<span class="fc" id="L41">		List&lt;Attraction&gt; attractions = gpsUtilService.getAttractions();</span>
<span class="fc" id="L42">		List&lt;VisitedLocation&gt; visitedLocationList = user.getVisitedLocations();</span>

<span class="fc" id="L44">		visitedLocationList.stream().parallel()</span>
<span class="fc" id="L45">				.forEach(visitedLocation -&gt; attractions.stream().filter(</span>
<span class="fc" id="L46">						attraction -&gt; user.getUserRewards().stream().noneMatch(r -&gt; r.attraction.attractionName.equals(attraction.attractionName))</span>
<span class="fc" id="L47">				).parallel().forEach(</span>
<span class="fc" id="L48">						attraction -&gt; calculateDistanceReward(user, visitedLocation, attraction)</span>
				));

<span class="fc" id="L51">	}</span>

	public void calculateDistanceReward(User user, VisitedLocation visitedLocation, Attraction attraction) {
<span class="fc" id="L54">		double distance = getDistance(attraction, visitedLocation.location);</span>
<span class="fc bfc" id="L55" title="All 2 branches covered.">		if(distance &lt;= proximityBuffer) {</span>
<span class="fc" id="L56">			UserReward userReward = new UserReward(visitedLocation, attraction, (int) distance);</span>
<span class="fc" id="L57">			addRewardPointsToUser(userReward, attraction, user);</span>
		}
<span class="fc" id="L59">	}</span>

	private void addRewardPointsToUser(UserReward userReward, Attraction attraction, User user) {
<span class="fc" id="L62">		CompletableFuture.supplyAsync(() -&gt; rewardsCentral.getAttractionRewardPoints(attraction.attractionId, user.getUserId())</span>
				, service)
<span class="fc" id="L64">				.thenAccept(points -&gt; {</span>
<span class="fc" id="L65">					userReward.setRewardPoints(points);</span>
<span class="fc" id="L66">					user.addUserReward(userReward);</span>
<span class="fc" id="L67">				});</span>
<span class="fc" id="L68">	}</span>

	public int getAttractionRewardPoint(Attraction attraction, User user) {
<span class="fc" id="L71">		return rewardsCentral.getAttractionRewardPoints(attraction.attractionId, user.getUserId());</span>
	}

	public List&lt;Attraction&gt; getSortedAttractions (List&lt;Attraction&gt; attractions, VisitedLocation visitedLocation) {
<span class="fc" id="L75">		attractions.sort((o1, o2) -&gt; (int) (getDistance(o1, visitedLocation.location) - getDistance(o2, visitedLocation.location)));</span>

<span class="fc" id="L77">		return attractions.stream().limit(5).collect(Collectors.toList());</span>
	}
	
	public double getDistance(Location loc1, Location loc2) {
<span class="fc" id="L81">        double lat1 = Math.toRadians(loc1.latitude);</span>
<span class="fc" id="L82">        double lon1 = Math.toRadians(loc1.longitude);</span>
<span class="fc" id="L83">        double lat2 = Math.toRadians(loc2.latitude);</span>
<span class="fc" id="L84">        double lon2 = Math.toRadians(loc2.longitude);</span>
<span class="fc" id="L85">        double angle = Math.acos(Math.sin(lat1) * Math.sin(lat2)</span>
<span class="fc" id="L86">                               + Math.cos(lat1) * Math.cos(lat2) * Math.cos(lon1 - lon2));</span>

<span class="fc" id="L88">        double nauticalMiles = 60 * Math.toDegrees(angle);</span>
<span class="fc" id="L89">		return STATUTE_MILES_PER_NAUTICAL_MILE * nauticalMiles;</span>
	}
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>